using System;
using System.Collections.Generic;
using System.Text;

namespace ARC2
{
    class LogClass
    {
        public static void LogErrorToDisk(string error)
        {
            string logMessage = "\n***********************************************\n" +
                    DateTime.Now + "\n" +
                error + "\n" +
                "***********************************************";
            

            if (System.Diagnostics.Debugger.IsAttached)//Likely that we're running in the IDE
            {
                System.Windows.Forms.MessageBox.Show(logMessage);
            }
            else
            try
            {
                Console.Beep();
                

                System.IO.File.AppendAllText(@"c:\ARC2ErrorLog.txt", logMessage);
            }
            catch (Exception ex)
            {
                System.Windows.Forms.MessageBox.Show(ex.Message);
            }
        }

    }
}
