using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace ARC2
{
    static class Program
    {
        public static bool autoShutdown = true;
        public static int retries = 0;

        public static string targetHost="";
        public static string sessionPassword="";
        public static string sessionID="";
        public static int targetPort=5500;

        public static bool beginConnectionImmediately=false;

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Properties.Settings currentSettings = new ARC2.Properties.Settings();

            if (Environment.GetCommandLineArgs().Length > 1)
            {
                beginConnectionImmediately = true;
                if (Validation.ValidateCommandLine() == false)
                {

                    return;
                }

            }
            else
            {
                if (string.IsNullOrEmpty(currentSettings.ConnectTo) == false)
                {
                    beginConnectionImmediately = true;
                    if (Validation.ValidateApplicationSettings() == false)
                    {

                        return;
                    }
                }
            
            }

            //if cmd line args are used, verify if they're legal
            //ValidateCommandLine()

            //else check if there are appsettings used, and verify them
            //ValidateApplicationSettings()

            //if any errors, output error to console and quit
            //bool ValidateSettings(bool OutputToConsole)

            //launch form1:
            //if either cmd line or appsettings were used, begin connection
            //otherwise just wait for manuel input

            //const int ATTACH_PARENT_PROCESS = -1;
            //AttachConsole(ATTACH_PARENT_PROCESS);
            //Console.WriteLine("\nblablahblah");
            ////foreach (string arg in args)
            ////{
            ////    Console.WriteLine(arg);
            ////}
            //ReleaseConsole();

            //NativeMethods.OutputToConsole("Loading");

            //string[] args = Environment.GetCommandLineArgs();

            //if (args.Length > 1)
            //{
            //    NativeMethods.OutputToConsole(args[1]);
            //    return;
            //}


            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1());

            //NativeMethods.OutputToConsole("Closing");
        }

        private static void ReleaseConsole()
        {
            FreeConsole();
            // simulate return pressing
            INPUT input = new INPUT();
            input.type = 1; // INPUT_KEYBOARD
            input.ki.wVk = 0x0D; // VK_RETURN
            SendInput(1, ref input, System.Runtime.InteropServices.Marshal.SizeOf(input));
            input.ki.dwFlags = 2; // KEYEVENTF_KEYUP
            SendInput(1, ref input, System.Runtime.InteropServices.Marshal.SizeOf(input));
        }

        [System.Runtime.InteropServices.DllImport("kernel32.dll")]
        private extern static bool AttachConsole(Int32 pid);

        [System.Runtime.InteropServices.DllImport("kernel32.dll")]
        private extern static bool FreeConsole();

        [System.Runtime.InteropServices.DllImport("user32")]
        public static extern int SendInput(int cInputs, ref INPUT pInputs, int cbSize);

        public struct KEYDBINPUT
        {
            public Int16 wVk;
            public Int16 wScan;
            public Int32 dwFlags;
            public Int32 time;
            public Int32 dwExtraInfo;
            public Int32 __filler1;
            public Int32 __filler2;
        }

        public struct INPUT
        {
            public Int32 type;
            public KEYDBINPUT ki;
        }
    }
}